unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, SharedMemory,
  StdCtrls;

type
  TForm1 = class(TForm)
    BtnEscribirEnMemoria: TButton;
    BtnLeerValores: TButton;
    EdPosMem: TEdit;
    EdValor: TEdit;
    ChBxFlush: TCheckBox;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BtnEscribirEnMemoriaClick(Sender: TObject);
    procedure BtnLeerValoresClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  CONST
  NMaxBytes = 15;  { Por ejemplo }



var
  Form1: TForm1;
  VAR
  SM: TSharedMemory;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 SM := TSharedMemory.Create('Probando',          { Nombre de la memoria compartida }
                             'Nombre del mutex',  { Nombre del mutex }
                             NMaxBytes,           { Nmero de bytes a compartir }
                             Nil,                 { Atributos de seguridad -> Nil es por defecto }
                             'C:\UnFichero.dat'); { Fichero (si hay) }
end;

procedure TForm1.BtnEscribirEnMemoriaClick(Sender: TObject);
VAR
  Pos, Valor: Integer;
begin
  Pos := StrToIntDef(EdPosMem.Text, -1);
  Valor := StrToIntDef(EdValor.Text, -1);

  IF (Pos > 0) AND (Pos <= NMaxBytes) AND (Valor >= 0) AND (Valor <= 255) THEN
    IF ChBxFlush.Checked THEN
      TRY
        SM.WriteValueFlush(Pos, Valor);
      EXCEPT
        ON E: ESharedMemoryError DO
          ShowMessage('Error!');
      END
    ELSE
      TRY
        SM.WriteValue(Pos, Valor);
      EXCEPT
        ON E: ESharedMemoryError DO
          ShowMessage('Error!');
      END
  ELSE
    ShowMessage('Valores incorrectos en los campos');
end;

procedure TForm1.BtnLeerValoresClick(Sender: TObject);
VAR
  i: Integer;
begin
  Memo1.Clear;

  FOR i := 1 TO NMaxBytes DO
    TRY
      Memo1.Lines.Add('Posicin: ' + IntToStr(i) + ' - '
        + 'Valor: ' + IntToStr(SM.ReadValue(i)));
    EXCEPT
      ON E: ESharedMemoryError DO
        ShowMessage('Error!');
    END
end;

end.
 